
// data base to set the CYCLES PER LINE

CYCLES_PER_LINE = (float)113.6363492063492;
CYCLES_PER_DMA = 514;
CYCLES_BEFORE_NMI = (float)1.0;
BANKSWITCH_PER_TILE = 0;
DPCM_IRQ = 1;

// Mapper 000 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 0)
{
  if(sum_16k_rom == 0x1ba6a0 || // Excite Bike (JU)
     sum_16k_rom == 0x1ba69f)   // Excite Bike (E)
  {
    CYCLES_PER_LINE = 112;
  }
  if(sum_16k_rom == 0x1a5bd4)   // Star Force
  {
    CYCLES_PER_DMA = 0;
  }
}

// Mapper 001 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 1)
{
  if(sum_16k_rom == 0x1d7202)   // Konamic Sports in Seoul
  {
    BANKSWITCH_PER_TILE = 1;
  }
  if(sum_16k_rom == 0x201d37)   // Romancia
  {
    DPCM_IRQ = 1;
  }
  if(sum_16k_rom == 0x1F2A91)   // Mario Open Golf
  {
    CYCLES_PER_LINE = 105;
  }
  if(sum_16k_rom == 0x1D6CEB)   // Gekitou !! Stadium
  {
    CYCLES_PER_LINE = 111;
  }
  if(sum_16k_rom == 0x1A7D9C)   // Hyokkori Hyoutan Jima
  {
    CYCLES_PER_LINE = 112;
  }
  if(sum_16k_rom == 0x1A2A69)   // Dengeki Big Bung!
  {
    CYCLES_PER_LINE = 115;
  }
  if(sum_16k_rom == 0x1B4A84 || // Itadaki Street
     sum_16k_rom == 0x1D34A3)   // Marusa No Onna
  {
    CYCLES_PER_LINE = 120;
  }
  if(sum_16k_rom == 0x23814A)   // Viva Lasvegas
  {
    CYCLES_PER_LINE = 130;
  }
}

// Mapper 002 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 2)
{
  if(sum_16k_rom == 0x18EF78)   // Esper Bouken Tai
  {
    CYCLES_PER_LINE = 128;
  }
}

// Mapper 003 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 3)
{
  if(sum_16k_rom == 0x17E9EC)   // Famiy Trainer - Dai Undoukai
  {
    CYCLES_PER_LINE = 113;
  }
  if(sum_16k_rom == 0x1C1015)   // Tokoro San No Mamorumo Semerumo
  {
    CYCLES_PER_LINE = 115;
    CYCLES_BEFORE_NMI = 10;
    BANKSWITCH_PER_TILE = 1;
  }
  if(sum_16k_rom == 0x182588)   // Guardic Gaiden
  {
    CYCLES_PER_LINE = 136;
  }
}

// Mapper 004 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 4)
{
  if(sum_16k_rom == 0x1537be)   // Gun-Dec
  {
    BANKSWITCH_PER_TILE = 1;
  }
  if(sum_16k_rom == 0x1B2FD6)   // JuJu Densetsu
  {
    CYCLES_PER_LINE = 112;
  }
  if(sum_16k_rom == 0x19c1df)   // Mother
  {
    CYCLES_PER_LINE = 114;
    BANKSWITCH_PER_TILE = 1;
  }
  if(sum_16k_rom == 0x184700)   // F-1 Sensation
  {
    CYCLES_PER_LINE = 115;
  }
  if(sum_16k_rom == 0x1C0F55 || // Ys 2
     sum_16k_rom == 0x204A60 || // Yume Penguin Monogatari
     sum_16k_rom == 0x1CCE66)   // Radia Senki - Reimen Hen
  {
    CYCLES_PER_LINE = 120;
  }
  if(sum_16k_rom == 0x1B640A || // Utsuru Desu
     sum_16k_rom == 0x1AEA1F || // Cattou Ninden Teyandee
     sum_16k_rom == 0x13E9F1 || // Doki! Doki! Yuuenchi
     sum_16k_rom == 0x1A838A || // Kunio Kun No Nekketsu Soccer League
     sum_16k_rom == 0x191ADE || // Jigoku Gokuraku Maru
     sum_16k_rom == 0x178C4E || // Jackie Chan
     sum_16k_rom == 0x1C4793 || // Nekketsu Kakutou Densetsu
     sum_16k_rom == 0x1A55C1 || // Heavy Barrel
     sum_16k_rom == 0x1EF74D || // Might and Magic
     sum_16k_rom == 0x1A5DE3)   // Light no Rockboard - That's Paradise
  {
    CYCLES_PER_LINE = 128;
  }
  if(sum_16k_rom == 0x1BEAAD || // Ike Ike Nekketsu Hockey Bu
     sum_16k_rom == 0x1C5534 || // Dai Kaijuu - Deburas
     sum_16k_rom == 0x1C9B6A || // Tecmo Super Bowl
     sum_16k_rom == 0x1CF307 || // Top Gun 2
     sum_16k_rom == 0x1F7B7E)   // Mitsume Ga Tooru
  {
    CYCLES_PER_LINE = 136;
  }
  if(sum_16k_rom == 0x176713 || // Asmik Kun Land
     sum_16k_rom == 0x21F12C || // God Slayer
     sum_16k_rom == 0x1CA6D6 || // Super Mario Bros 3 (J)
     sum_16k_rom == 0x1c7f71 || // Super Mario Bros 3 (E)
     sum_16k_rom == 0x1AF537 || // Sugoro Quest
     sum_16k_rom == 0x183F0F || // Time Zone
     sum_16k_rom == 0x207C77 || // Chiki Chiki Machine Mou Race
     sum_16k_rom == 0x193762 || // Nekketsu Koukou Dodge Ball Bu Soccer Hen
     sum_16k_rom == 0x1EEE52 || // Nekketsu Street Basket
     sum_16k_rom == 0x17EF04 || // Matendouji
     sum_16k_rom == 0x1CCEC0)   // Wanpaku Kokkun No Gourmet World
  {
    CYCLES_PER_LINE = 144;
  }
  if(sum_16k_rom == 0x1DFD66 || // 1999 - Hore, Mitakotoka! Seikimatsu
     sum_16k_rom == 0x2C77AF || // SD Battle Oozumou
     sum_16k_rom == 0x19EE1B || // KLAX
     sum_16k_rom == 0x1A1A79 || // Soreike! Anpanman
     sum_16k_rom == 0x144C61 || // Bananan Ouji No Dai Bouken
     sum_16k_rom == 0x1986D2)   // Meimon! Takonishi Ouendan - Kouha 6 Nin Shuu
  {
    CYCLES_PER_LINE = 152;
  }
}

// Mapper 007 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 7)
{
  if(sum_16k_rom == 0x1929c0 || // Battletoad (E)
     sum_16k_rom == 0x191c42 || // Battletoad (J)
     sum_16k_rom == 0x192aea)   // Battletoad (U)
  {
    CYCLES_PER_LINE = 114;
  }
}

// Mapper 016 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 16)
{
  if(sum_16k_rom == 0x179505 || // Dragon Ball 3 Gokuu Den
     sum_16k_rom == 0x14e3fb)   // Nishimura Kyoutarou Mystery - Blue Train Satsujin Jiken
  {
    CYCLES_PER_LINE = 122;
  }
}

// Mapper 018 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 18)
{
  if(sum_16k_rom == 0x1E50AA)   // Toukon Club
  {
    CYCLES_PER_LINE = 114;
  }
}

// Mapper 019 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 19)
{
  if(sum_16k_rom == 0x1df03e)   // Youkai Douchuuki
  {
    BANKSWITCH_PER_TILE = 1;
  }
  if(sum_16k_rom == 0x116d68)   // Digital Devil Story - Megami Tensei 2
  {
    CYCLES_PER_LINE = 119;
  }
  if(sum_16k_rom == 0x144A33)   // Namco Classic 2
  {
    CYCLES_PER_LINE = 120;
  }
  if(sum_16k_rom == 0x116d68 || // Namco Classic
     sum_16k_rom == 0x18B0B9)   // Rolling Thunder
  {
    CYCLES_PER_LINE = 144;
  }
  if(sum_16k_rom == 0x18e316)   // Dokuganryuu Masamune
  {
    CYCLES_BEFORE_NMI = 10;
  }
}

// Mapper 020 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 20)
{
  uint8 id0 = ROM_banks[0x1f];
  uint8 id1 = ROM_banks[0x20];
  uint8 id2 = ROM_banks[0x21];
  uint8 id3 = ROM_banks[0x22];
  uint8 id4 = ROM_banks[0x23];

  if(// Kinnikuman - Kinnikusei Oui Soudatsusen
     (id0 == 0xb2 && id1 == 0x4b && id2 == 0x4e && id3 == 0x4d && id4 == 0x20) ||
     // Legend of Zelda 2 - Link no Bouken, The
     (id0 == 0x01 && id1 == 0x4c && id2 == 0x4e && id3 == 0x4b && id4 == 0x20) ||
     // Super Boy Allan
     (id0 == 0xc1 && id1 == 0x41 && id2 == 0x4c && id3 == 0x4e && id4 == 0x20))
  {
    CYCLES_PER_LINE =117;
  }
}

// Mapper 021 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 21)
{
  if(sum_16k_rom == 0x1A76FC)   // Wai Wai World 2 - SOS!! Paseri Jou
  {
    CYCLES_PER_LINE = 117;
  }
}

// Mapper 023 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 23)
{
  if(sum_16k_rom == 0x1BB417)   // Wai Wai World
  {
    CYCLES_PER_LINE = 115;
  }
}

// Mapper 024 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 24)
{
  if(sum_16k_rom == 0x182059)   // Akumajou Densetsu
  {
    CYCLES_PER_LINE = 119;
  }
}

// Mapper 032 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 32)
{
  if(sum_16k_rom == 0x172273)   // Meikyuu Jima
  {
    CYCLES_PER_LINE = 114;
  }
}

// Mapper 065 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 65)
{
  if(sum_16k_rom == 0x180695)   // Spartan X 2
  {
    CYCLES_PER_LINE = 125;
  }
}

// Mapper 094 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 94)
{
  if(sum_16k_rom == 0x180695)   // Senjou no Ookami
  {
    CYCLES_PER_LINE = 117;
  }
}

